#include <stdio.h>
#include "g721.h"

U16BIT Input[] = 
{
  0xff, 0xa7, 0x19, 0x92, 0x0f, 0x91, 0x18, 0xa3,
  0x4d, 0x2b, 0x9a, 0x13, 0x8f, 0x11, 0x96, 0x20,
  0xbe, 0xaf, 0x1c, 0x94, 0x10, 0x90, 0x15, 0x9e,
  0x36, 0x36, 0x9e, 0x15, 0x90, 0x10, 0x94, 0x1c
} ;

U16BIT Output[] =
{
  0xff, 0xf4, 0x70, 0xec, 0x68, 0xe0, 0x59, 0xcd,
  0x4d, 0x4c, 0xaf, 0x14, 0x90, 0x12, 0x98, 0x1e,
  0xbe, 0xb3, 0x1e, 0x92, 0x0f, 0x90, 0x15, 0xa1,
  0x30, 0x3c, 0x9f, 0x15, 0x90, 0x11, 0x96, 0x1d
} ;

extern int __time;

int main(void)
{
  int i, sic, eic;
  U16BIT I;

  reset_encoder();
  reset_decoder();

  sic = __time / 2;
  for (i = 0; i < sizeof(Input) / sizeof(U16BIT); i++)
  {
    U16BIT IX;

    I = encoder(Input[i]);
    if ((IX = decoder(I)) != Output[i])
    {
      printf("\n*** TRANSCODE ERROR with sample No. %d!", i);
      printf("\n    %d instead of %d received", IX, Output[i]);
/*      exit(-1); */
    }
  }
  eic = __time / 2;
  printf("\nInstruction cycles for transcoding a sample: %d\n",
	 (eic - sic) / (sizeof(Input) / sizeof(U16BIT)));

  return (0);
}
