/*
 * benchmark program:   complex_multiply_ext.c
 * 
 * benchmark suite:     DSP-kernel
 * 
 * description:         complex_multiply - filter benchmarking
 * 
 * reference code:      target assembly
 * 
 * f. verification:     simulator based
 * 
 *  organization:        Aachen University of Technology - IS2 
 *                       DSP Tools Group
 *                       phone:  +49(241)807887 
 *                       fax:    +49(241)8888195
 *                       e-mail: zivojnov@ert.rwth-aachen.de 
 *
 * author:              Juan Martinez Velarde
 * 
 * history:             09-05-94 creation (Martinez Velarde)(complex_multiply.c)
 *                      20-02-95 language extensions (Harald L. Schraut)
 *
 *                      $Author: dehofman $
 *                      $Revision: 1.1 $
 *                      $Date: 1996/09/16 14:53:14 $
 */

#define STORAGE_CLASS static
#define TYPE  int

void
pin_down(TYPE *ar, TYPE *ai,TYPE pm *br, TYPE pm *bi, TYPE *cr, TYPE *ci)
{
  *ar = 2 ; 
  *ai = 1 ; 
  *br = 2;
  *bi = 5;
}

void
main()
{
  STORAGE_CLASS TYPE dm ar, ai ;
  STORAGE_CLASS TYPE pm br, bi;
  STORAGE_CLASS TYPE dm cr, ci ;

  pin_down(&ar, &ai, &br, &bi, &cr, &ci) ;
  

  START_PROFILING;
  
  cr  = ar*br - ai*bi ;
  ci  = ar*bi + ai*br ;

  END_PROFILING;

  pin_down(&ar, &ai, &br, &bi, &cr, &ci) ;

}


