;  benchmark program  : complex_multiply_arc.asm
; 
;  benchmark suite    : DSP-kernel
;
;  description        : benchmarking of a complex_multiply operation
;
;  reference          : none
;
;  func. verification : with sim5x simulator 
;
;  organization       : Aachen University of Technology - IS2
;                     : DSP Tools Group
;                     : phone   : +49(241)807887
;                     : fax     : +49(241)8888195
;                     : e-mail  : zivojnov@ert.rwth-aachen.de
;
;  author             : Juan Martinez Velarde
;
;  history            : 10-05-94 - assembler reference code creation 
;                       10-05-94 - assembler reference code profiling

        .mmregs

        .file  "complex_multiply_arc.asm"
        .title "complex_multiply assembler reference code"
	.width 120

AR		.set 	060h
AI		.set	061h
BR        	.set	062h
BI		.set	063h
CR		.set	064h
CI		.set	065h

	.sect "avalue"
	.word 2,1 		; ar and ai
;	      ^
;           0x60

	.sect "bvalue"
	.word 2,5		; br and bi
;             ^
;           0x62

	.sect "cvalue"
	.word 0,0		; cr and ci
;	      ^
;	    0x64

        .sect ".text"
INIT:
        LAR        AR1,#AR         
	LAR	   AR2,#BR
	LAR	   AR3,#CR
	LAR	   AR4,#AI
	LAR	   AR5,#BI
	LAR	   AR6,#CI
	ZPR		 ; zero product register 	
	LACC	   0	 ; clear accumulator
        MAR        *,AR1 ; point to ar1

START_PROFILING:

	LT	*,AR2	;treg = ar,arp = ar2
	MPY	*,AR4	;preg = treg * br,arp = ar4 
	LTP	*,AR5	;acc = preg,treg = ai,arp = ar5
	MPY	*,AR3	;preg = treg * bi,arp = ar3
	SPAC		;acc -= preg
        SACL    *,AR1	;store cr,arp = ar1

	LT	*,AR5	;treg = ar,arp = ar5
	MPY	*,AR4	;preg = treg * bi,arp = ar4
	LTP	*,AR2	;acc = preg,treg = ai,arp = ar2
	MPY	*,AR6	;preg = treg * br,arp = ar6
	APAC		;acc += preg
	SACL	*	;store ci

END_PROFILING:

END:        B END

        .end