;  benchmark program  : complex_update_arc.asm
; 
;  benchmark suite    : DSP-kernel
;
;  description        : benchmarking of a complex_update operation
;
;  reference          : none
;
;  func. verification : with sim5x simulator 
;
;  organization       : Aachen University of Technology - IS2
;                     : DSP Tools Group
;                     : phone   : +49(241)807887
;                     : fax     : +49(241)8888195
;                     : e-mail  : zivojnov@ert.rwth-aachen.de
;
;  author             : Juan Martinez Velarde
;
;  history            : 25-05-94 - assembler reference code creation 
;                       25-05-94 - assembler reference code profiling

        .mmregs

        .file  "complex_update_arc.asm"
        .title "complex_update assembler reference code"
	.width 120

A		.set 	060h
B		.set	062h
C        	.set	064h
D		.set	066h

	.sect "avalue"
	.word 	2,1 		;ar,ai
;		^
;		0x60

	.sect "bvalue"
	.word 	2,5		;br,bi
;		^
;		0x62

	.sect "cvalue"
	.word 	3,4		;cr,ci
;		^
;		0x64

	.sect "dvalue"
	.word	0,0		;dr,di
;		^
;		0x66

        .sect ".text"
INIT:
        LAR        AR1,#A         
	LAR	   AR2,#B
	LAR	   AR3,#C
	LAR	   AR4,#D
	ZPR		 ; zero product register 	
	LACC	   0	 ; clear accumulator
        MAR        *,AR3 ; point to #C

START_PROFILING:

	LACC	*+,AR1	;accu = cr
	LT	*+,AR2	;treg = ar,arp = ar2
	MPY	*+,AR1	;preg = ar*br,arp = ar1
	APAC		;accu = cr + ar*br
	LT	*-,AR2  ;treg = ai,arp = ar2
	MPY	*,AR4   ;preg = ai*bi,arp = ar4
	SPAC	        ;accu = cr + ar*br - ai*bi
	SACL	*+,AR3	;store dr
	
	LACC	*,AR1   ;accu = ci
	LT	*+,AR2	;treg = ar,arp = ar2
	MPY	*-,AR1  ;preg = ar*bi,arp = ar1
	APAC		;accu = ci + ar*bi
	LT	*,AR2	;treg = ai,arp = ar2
	MPY	*,AR4	;preg = ai*br,arp = ar4
	APAC		;accu = ci + ar*bi + ai*br
	SACL	*,AR3	;store di

END_PROFILING:

END:        B END

        .end