/*
 * benchmark program:   convolution_ext.c
 * 
 * benchmark suite:     DSP-kernel
 * 
 * description:         convolution - filter benchmarking
 * 
 * reference code:      target assembly
 * 
 * f. verification:     none
 * 
 *  organization:        Aachen University of Technology - IS2 
 *                       DSP Tools Group
 *                       phone:  +49(241)807887 
 *                       fax:    +49(241)8888195
 *                       e-mail: zivojnov@ert.rwth-aachen.de 
 *
 * author:              Vojin Zivojnovic
 * 
 * history:             14-01-94 creation (Vojin Zivojnovic)(convolution.c)
 *                      18-03-94 asm labels included (Martinez Velarde)
 *                      22-02-95 language extensions (Harald L. Schraut)
 *
 *                      $Author: schraut $
 *                      $Date: 1995/03/05 12:04:04 $
 *                      $Revision: 1.1 $
 */

#define STORAGE_CLASS register
#define TYPE  int
#define LENGTH 16

void pin_down(TYPE pm * px, TYPE * ph)
{
	STORAGE_CLASS TYPE    i;

	for (i = 0; i < LENGTH; ++i) {
		*px++ = 1;
		*ph++ = 1;
	}

}


TYPE main()
{

	static TYPE pm x[LENGTH];
	static TYPE dm h[LENGTH];

	STORAGE_CLASS TYPE y;
	STORAGE_CLASS TYPE i;
	STORAGE_CLASS TYPE pm *px = x;
	STORAGE_CLASS TYPE dm *ph = &h[LENGTH - 1];
        

	pin_down(&x[0], &h[0]);

	START_PROFILING;

	y = 0;

	for (i = 0; i < LENGTH; ++i)
		y += *px++ * *ph--;

	END_PROFILING;


	return ((TYPE) y);

}

