; **************************************************
; /*
;  * benchmark program:   fir_arc.asm
;  * 
;  * benchmark suite:     DSP-kernel
;  * 
;  * description:         integer fir - filter benchmarking
;  * 	
;  * 			  real correlation or convolution
;  *
;  *                      y(n) = SUM(i=0 ... N-1) (a(i) * b (n-i))
;  *
;  * reference code:      dsp56100 family manual
;  *                      first set of benchmarks, p.B-6.
;  * 
;  * f. verification:     with printf function
;  * 
;  *  organization:        Aachen University of Technology - IS2 
;  *                       DSP Tools Group
;  *                       phone:  +49(241)807887 
;  *                       fax:    +49(241)8888195
;  *                       e-mail: zivojnov@ert.rwth-aachen.de 
;  *
;  * author:              Juan Martinez Velarde
;  * 
;  * history:             24-3-94 creation and profiling (Martinez Velarde)
;  * 
;  */

	section fir_arc
	opt so,nomd,cc
	
	org	x: 	; samples  and coefficients in x memory
F___x0: dc 1
	dc 2
	dc 3
	dc 4
	dc 5
	dc 6
	dc 7
	dc 8
	dc 9
	dc 10
	dc 11
	dc 12
	dc 13
	dc 14
	dc 15
	dc 16

F___h1:	dc 1
	dc 2
	dc 3
	dc 4	
	dc 5
	dc 6
	dc 7
	dc 8	
	dc 9
	dc 10
	dc 11
	dc 12
	dc 13
	dc 14
	dc 15
F___hn:	dc 16

LC0
	dc	'y',$3D,$25,'i',$0A,$0A,$00
	org	p:
	global	Fmain
Fmain
	move	ssh,x:(r2)+
	move 	#F___x0,r0
	move	#F___hn,r3 
	move	#-1,n3

ASM_APP_0
	START_PROFILING:
ASM_APP_1

	clr	a 	x:(r0)+,x0	
	move	x:(r3)-,y0
	
	rep	#16
	mac	y0,x0,a	x:(r0)+,y0 x:(r3)+n3,x0 	; y += *px++ * *ph--;

	asr	a

ASM_APP_2
	END_PROFILING:
ASM_APP_3

; **************************************************
	move	#LC0,r1
	move	a0,x:(r2)+
	move	r1,x:(r2)+
	jsr	Fprintf
; **************************************************
	move 	(r2)-
	move	(r2)-
	move	x:-(r2),ssh
	rts
	endsec
