;  benchmark program  : dot_product_arc.asm
; 
;  benchmark suite    : DSP-kernel
;
;  description        : benchmarking of a dot_product operation
;
;  reference          : none
;
;  func. verification : with sim5x simulator 
;
;  organization       : Aachen University of Technology - IS2
;                     : DSP Tools Group
;                     : phone   : +49(241)807887
;                     : fax     : +49(241)8888195
;                     : e-mail  : zivojnov@ert.rwth-aachen.de
;
;  author             : Juan Martinez Velarde
;
;  history            : 25-05-94 - assembler reference code creation 
;                       25-05-94 - assembler reference code profiling

        .mmregs

        .file  "dot_product_arc.asm"
        .title "dot_product assembler reference code"
	.width 120

A		.set 	060h
B		.set	062h
Z        	.set	064h

	.sect "avector"
	.word 	2,1 		; a
;		^
;		0x60

	.sect "bvector"
	.word 	2,5		; b
;		^
;		0x62

	.sect "zvalue"
	.word 	0		; c
;		^
;		0x64

        .sect ".text"
INIT:
        LAR	AR1,#A         
	LAR	AR2,#B
	LAR	AR3,#Z
	ZPR		 ; zero product register 	
	LACC	0	 ; clear accumulator
        MAR     *,AR1 ; point to #A

START_PROFILING:

	LACK	1
	SAMM	BRCR
	LACC	0

	RPTB	L1-1
	LT	*+,AR2	;treg = ai,arp = ar2
	MPY	*+,AR1	;preg = ai*bi,arp = ar1
	APAC		;accu += ai*bi
L1
	MAR	*,AR3
	SACL	*	;store Z

END_PROFILING:

END:        B END

        .end