;
; file: INIT-FFT.ASM --> same for all 320C50 RADIX complex FFTs
;
; Update:21.3.94 / Vers.: 2.00 / Manfred Christ / Texas Instruments - Freising
;
         .mmregs
;
pmstmask .set	 03eh	      ; ovly=ram=ndx=trm=1/ MP=1-> ROM disabled
;
	 .include C5CXRAD2.ASM
;
	 .def	 callfft,wait,STAGE1,STAGE3
	 .def	 cos45,N,TWIDLEN,FFTLEN,TEMP,pmstmask
         .def    INIT,FFT,INPUT,DATA,TWID
;
         .sect   "twiddles"
TWIDSTRT .include twiddles.q15   ; table of twiddle factors for the FFT
	 .if	 N>1024
	 .include twid2048.q15
	 .endif
TWIDEND  .set    $
TWIDLEN  .set    TWIDEND-TWIDSTRT
;
INPUT    .usect  "input",N*2     ; input data array
TWID     .usect  "twid",TWIDLEN  ; reserve space for twiddles
DATA     .usect  "fftdata",N*2   ; working data array
;
;  Initialized  variables
;
         .sect   "init"
         .bss    NN,1            ; number of fft-points
         .bss    NN1,1           ; N-1
         .bss    NN2,1           ; 2*N-1
         .bss    DATAADD,1       ; START ADDRESS OF DATA
         .bss    DATA2,1         ; DATA+2
         .bss    DATA4,1         ; DATA+4
         .bss    DATA6,1         ; DATA+6
         .bss    DATA8,1         ; DATA+8
         .bss    DATA16,1        ; DATA+16
;
TABINIT: .word   N,N-1,2*N-1,DATA,DATA+2,DATA+4,DATA+6,DATA+8,DATA+16
;
; stage 3 constants
;
         .word   5A82h           ; cos(45)=sin(45)
         .bss    cos45,1         ; sine/cosine in stage 3
;
; stage 4 constants
;
	 .if N>8
	 .def	 STAGE4,SINES4,MACROLEN
SINES4   .set    TWID            ; start of sine in stage 4
         .word   SINES4,SINES4+4
         .bss    sin4,1          ; start of sine in stage    4
         .bss    cos4,1          ; start of cosine in stage  4
	 .endif
;
         .if N>16
         .def    STAGE5,SINES5
SINES5   .set    SINES4+11       ; start of sine in stage 5
         .word   DATA+32,SINES5,SINES5+8
         .bss    DATA32,1        ; DATA+32
         .bss    sin5,1          ; start of sine in stage    5
         .bss    cos5,1          ; start of cosine in stage  5
         .endif
;
         .if N>32
         .def    STAGE6,SINES6
SINES6   .set    SINES5+23       ; start of sine in stage 6
         .word   DATA+64,SINES6,SINES6+16
         .bss    DATA64,1        ; DATA+64
         .bss    sin6,1          ; start of sine in stage    6
         .bss    cos6,1          ; start of cosine in stage  6
         .endif
;
         .if N>64
         .def    STAGE7,SINES7
SINES7   .set    SINES6+47       ; start of sine in stage 7
         .word   DATA+128,SINES7,SINES7+32
         .bss    DATA128,1       ; DATA+128
         .bss    sin7,1          ; start of sine in stage    7
         .bss    cos7,1          ; start of cosine in stage  7
         .endif
;
         .if N>128
         .def    STAGE8,SINES8
SINES8   .set    SINES7+95       ; start of sine in stage 8
         .word   DATA+256,SINES8,SINES8+64
         .bss    DATA256,1       ; DATA+256
         .bss    sin8,1          ; start of sine in stage    8
         .bss    cos8,1          ; start of cosine in stage  8
         .endif
;
         .if N>256
         .def    STAGE9,SINES9
SINES9   .set    SINES8+191      ; start of sine in stage 9
         .word   DATA+512,SINES9,SINES9+128
         .bss    DATA512,1       ; DATA+512
         .bss    sin9,1          ; start of sine in stage    9
         .bss    cos9,1          ; start of cosine in stage  9
         .endif
;
         .if N>512
; all 32 words in B2 are already used
         .def    STAGE10,SINES10 
SINES10  .set	 SINES9+383	  ; start of sine in stage 10
         .endif
;
TABEND:  .set    $
;
; Uninitialized temporary variables
;
         .bss    TEMP,2          ; temp variable
         .bss    sine,1          ; temp variable
         .bss    cosine,1        ; temp variable
;
         .sect "vectors"
         b       INIT
;
         .sect   "init"
INIT:    ldp     #0              ; use only B2 and mmregs for direct addressing
         mar     *,ar0           ; arp->ar0
         spm     0               ; no shift from PREG to ALU
         clrc    OVM             ; disable overflowmode
         setc    SXM             ; enable sign extension mode
         splk    #pmstmask,PMST  ; MC=0 / ndx=1 / trm=1 / memory configuration
         splk    #0,PDWSR        ; sw=0
         splk    #0,IOWSR        ; sw=0
         splk    #0,CWSR         ; sw=0           
;
; INIT Block B2
;
         lar     ar0,#NN         ; arp is already pointing to ar0
         lacc    #TABINIT
         rpt     #TABEND-TABINIT
         tblr    *+
;
; INIT TWIDDLE FACTORS
;
         lar     ar0,#TWID       ; arp is already pointing to ar0
         lacc    #TWIDSTRT       ; copy from program to datamemory
         rpt     #TWIDLEN
         tblr    *+
;
; EXECUTE THE FFT
;
callfft  calld	 FFT,*,AR3	 ; ARP=AR3 FOR MACRO COMBO
         lar     ar5,#TEMP       ; pointer to 2 temp register
;
	 nop
wait     b       wait            ; THE SIMULATOR STOPS HERE
