{   
    FIR 2 DIMENSIONAL Filter Subroutine           FIR2DIM_ARC 
    
    Calling Parameters
         I0 -> Beginning of Image Array           (first row)
         I1 -> Beginning of Image Array +    N+2  (second row)
         I2 -> Beginning of Image Array + 2*(N+2) (third row)
         I3 -> Beginning of Output Array
         I4 -> Beginning of Filter Coefficient Table

         M0, M3, M4 = 1
         M2, M6     = -1
         M5         = -8 ; 

    Reference 
         none
}

.MODULE                      fir2dim_arc;
.CONST                       N=4 ;          {filter length} ; 
.VAR/PM/RAM/ABS=0x0          coeff[N*N];
.VAR/DM/RAM                  image[(N+2)*(N+2)];
.VAR/DM/RAM		     output[N*N] ; 

.INIT                        coeff: 0x100, 0x100, 0x100, 0x100, 0x100, 0x100,
                                    0x100, 0x100, 0x100, 0x100, 0x100, 0x100,
                                    0x100, 0x100, 0x100, 0x100;

.INIT                        image:	0,0,0,0,0,0,
                                        0,1,1,1,1,0,
                                        0,1,1,1,1,0,
                                        0,1,1,1,1,0,
                                        0,1,1,1,1,0,
                                        0,0,0,0,0,0 ; 

.INIT                        output:	0,0,0,0,
                                        0,0,0,0,
                                        0,0,0,0,
                                        0,0,0,0 ; 
.ENTRY fir2dim_arc_;

fir2dim_arc_:
  
	 ENA M_MODE ; 

         I0=^image         ; L0=0; M0=1;
         I1=^image+N+2     ; L1=0; M1=2;
         I2=^image+2*(N+2) ; L2=0; M2=-1;
	 I3=^output        ; L3=0; M3=1; 
         I4=^coeff         ; L4=0; M4=1;
         M5 = -8;
	 M6 = -1 ; 

START_PROFILING:

         MX0=DM(I0,M0), MY0=PM(I4,M4); 

         CNTR = N ;
	 DO rows until ce ; 

         CNTR = N ;
	 DO cols until ce ; 

 	 MR=MX0*MY0(SS),   MX0=DM(I0,M0),MY0=PM(I4,M4);
 	 MR=MR+MX0*MY0(SS),MX0=DM(I0,M2),MY0=PM(I4,M4);
 	 MR=MR+MX0*MY0(SS),MX0=DM(I1,M0),MY0=PM(I4,M4);
 	 MR=MR+MX0*MY0(SS),MX0=DM(I1,M0),MY0=PM(I4,M4);
 	 MR=MR+MX0*MY0(SS),MX0=DM(I1,M2),MY0=PM(I4,M4);
 	 MR=MR+MX0*MY0(SS),MX0=DM(I2,M0),MY0=PM(I4,M4);
 	 MR=MR+MX0*MY0(SS),MX0=DM(I2,M0),MY0=PM(I4,M4);
 	 MR=MR+MX0*MY0(SS),MX0=DM(I2,M2),MY0=PM(I4,M5);
         MR=MR+MX0*MY0(SS),MX0=DM(I0,M0),MY0=PM(I4,M4); 
cols:	 DM(I3,M3)=MR0 ; 

	 MODIFY(I0,M0);
	 MODIFY(I4,M6);
	 MX0=DM(I0,M0), MY0=PM(I4,M4); 
	 MODIFY(I1,M1);
rows:    MODIFY(I2,M1);

	
END_PROFILING:

end:     JUMP START_PROFILING ; 

.ENDMOD;