	section	matrix_arc
	opt so,nomd
	page 132,66,3,3

;*** DSP56000/1 Motorola 1.11 GNU 1.37.1

; /*
;  * benchmark program:   matrix_arc.asm
;  *
;  * benchmark suite:     DSP-kernel
;  *
;  * description:         [XxY] [YxZ]  matrix - multiply benchmarking
;  *
;  *        |a11 a12  .. a1y|   |b11 b12  .. b1z|
;  *        |a21 a22  .. a2y| x |b21 b22  .. b2z|
;  *        |..  ..   ..  ..|   | .. ..   ..  ..|
;  *        |ax1 ax2  .. axy|   |by1 by2 ..  byz|
;  *
;  * Elements are to store in following order:
;  *
;  * matrix a[X*Y]={a11,a12,..,a1y,a21,a22,..,a2y,.., ax1,ax2,..,axy}
;  * matrix b[Y*Z]={b11,b12,..,b1z,b21,b22,..,b2z,.., by1,by2,..,byz}
;  * matrix c[X*Z]={c11,c21,..,cz1,c12,c22,..,cz2,.., c1x,c2x,..,cxz}
;  *
;  * reference code:   Motorola's Dr.Bub/56000/matrix/matmul2.asm (modified)
;  *
;  * f. verification:      with printf function
;  *
;  * organization:         Aachen University of Technology - IS2
;  *                       DSP Tools Group
;  *                       phone:  +49(241)807887
;  *                       fax:    +49(241)8888195
;  *                       e-mail: zivojnov@ert.rwth-aachen.de
;  *
;  * author:              Juan Martinez Velarde
;  *
;  * history:             07-04-94 creation (Martinez Velarde)
;  *
;  */
     
N 	equ  	10 
mx	equ	10	; first  dimension of A matrix
my	equ	10	; second dimension of A matrix, first of B matrix
mz	equ	10	; second dimension of B matrix

	org	x:
F___a
	dc  2	
	dc  2	
	dc  2	
	dc -2	
	dc  2	
	dc -2	
	dc  2	
	dc -2	
	dc  0	
	dc  9   
	dc  2	
	dc -2	
	dc  2	
	dc -2	
	dc  2	
	dc -2	
	dc  2	
	dc -2	
	dc  0	
	dc  9   
	dc  2	
	dc -2	
	dc  2	
	dc -2	
	dc  2	
	dc -2	
	dc  2	
	dc -2	
	dc  0	
	dc  9   
	dc  2	
	dc -2	
	dc  2	
	dc -2	
	dc  2	
	dc -2	
	dc  2	
	dc -2	
	dc  0	
	dc  9   
	dc  2	
	dc -2	
	dc  2	
	dc -2	
	dc  2	
	dc -2	
	dc  2	
	dc -2	
	dc  0	
	dc  9   
	dc  2	
	dc -2	
	dc  2	
	dc -2	
	dc  2	
	dc -2	
	dc  2	
	dc -2	
	dc  0	
	dc  9   
	dc  2	
	dc -2	
	dc  2	
	dc -2	
	dc  2	
	dc -2	
	dc  2	
	dc -2	
	dc  0	
	dc  9   
	dc  2	
	dc -2	
	dc  2	
	dc -2	
	dc  2	
	dc -2	
	dc  2	
	dc -2	
	dc  0	
	dc  9   
	dc  2	
	dc -2	
	dc  2	
	dc -2	
	dc  2	
	dc -2	
	dc  2	
	dc -2	
	dc  0	
	dc  9   
	dc  2	
	dc -2	
	dc  2	
	dc -2	
	dc  2	
	dc -2	
	dc  2	
	dc -2	
	dc  0	
	dc  9   

	org	y:
F___b
	dc  1	
	dc  1	
	dc  1	
	dc  1	
	dc  1	
	dc  1	
	dc  1	
	dc  1	
	dc  1	
	dc  1
	dc  1	
	dc  1	
	dc  1	
	dc  1	
	dc  1	
	dc  1	
	dc  1	
	dc  1	
	dc  1	
	dc  1
	dc  1	
	dc  1	
	dc  1	
	dc  1	
	dc  1	
	dc  1	
	dc  1	
	dc  1	
	dc  1	
	dc  1
	dc  1	
	dc  1	
	dc  1	
	dc  1	
	dc  1	
	dc  1	
	dc  1	
	dc  1	
	dc  1	
	dc  1
	dc  1	
	dc  1	
	dc  1	
	dc  1	
	dc  1	
	dc  1	
	dc  1	
	dc  1	
	dc  1	
	dc  1
	dc  1	
	dc  1	
	dc  1	
	dc  1	
	dc  1	
	dc  1	
	dc  1	
	dc  1	
	dc  1	
	dc  1
	dc  1	
	dc  1	
	dc  1	
	dc  1	
	dc  1	
	dc  1	
	dc  1	
	dc  1	
	dc  1	
	dc  1
	dc  1	
	dc  1	
	dc  1	
	dc  1	
	dc  1	
	dc  1	
	dc  1	
	dc  1	
	dc  1	
	dc  1
	dc  1	
	dc  1	
	dc  1	
	dc  1	
	dc  1	
	dc  1	
	dc  1	
	dc  1	
	dc  1	
	dc  1
	dc  1	
	dc  1	
	dc  1	
	dc  1	
	dc  1	
	dc  1	
	dc  1	
	dc  1	
	dc  1	
	dc  1

F___c
	ds mx*mz	; save enough space

LC0
	dc	$25,'i',$0A,$0A,$00

	org	p:
	global	Fmain
Fmain	
	move	ssh,y:(r6)+
        move    #F___b,r0       ;point to B matrix
        move    #F___c,r2       ;point to C matrix
	move	#my,n0          
	nop

ASM_APP_0
	START_PROFILING:
ASM_APP_1

        do      #mz,_ez         ;number of columns of B
        move    #F___a,r3       ;r4=begin of A
        do      #mx,_ex         ;number of rows of A
        move    r0,r4           ;r4=begin of actual column of B matrix
        clr a   
	move	x:(r3)+,x0  y:(r4)+,y0 ; 
        rep     #my-1           ;inner sum
        mac     x0,y0,a  x:(r3)+,x0  y:(r4)+,y0
        mac    	x0,y0,a   	;last multiplication and round result
        asr	a
	move    a0,y:(r2)+      ;save result
_ex
        move    (r0)+n0         ;move to next column in B
_ez

ASM_APP_2
	END_PROFILING:
ASM_APP_3


	move	#F___c,r0
	do 	#N*N,EP
	move	y:(r0)+,a1
	move	#LC0,r1
	move	a1,y:(r6)+
	move	r1,y:(r6)+
	jsr	Fprintf
	move 	(r6)-
	move	(r6)-
EP:
	move	y:-(r6),ssh
	rts
	endsec


