{                                                       MAT1X3_ARC.DSP
    Single Precision Matrix Multiply [1x3] [3x3]
    Calling Parameters
         I0 -> H(0,0) matrix
         I1 -> Beginning of output vector
         CNTR = 3

         M0=M1=M4=1 ; 
         L0=L1=L4=0;

    Return Values
         MR0 = Last MatrixMultiplication
         I0 -> Last Component of input vector 
         I4 -> Last Component of output vector

    Altered Registers
         MX0, MY0, MR
         I0, L0, M0
         I4, L4, M4

    All coefficients and data values are assumed to be in 1.15 format.}

.MODULE                mat1x3_arc;

.var/pm/ram/abs=0x11 x[3];
.var/dm/ram h[9];
.var/dm/ram y[3];

.init       x: 0x000100,0x000100,0x000100;
.init       h: 1,2,3,1,1,1,3,2,1;
.init       y: 0,0,0;

.entry        mat1x3_;

mat1x3_:
        m0=1;l0=0;
        m1=1;l1=0;
        m4=1;l4=0;
        i1=^y;
        i0=^h;

START_PROFILING:

        cntr = 3 ; 
        do L1_-1 until ce; 
        i4=^x;				{i4 points to ^x}
        mx1=dm(i0,m0),my1=pm(i4,m4) ;
        mr=mx1*my1(ss),mx1=dm(i0,m0),my1=pm(i4,m4) ;
        mr=mr+mx1*my1(ss),mx1=dm(i0,m0),my1=pm(i4,m4) ;
        mr=mr+mx1*my1(ss); 
        dm(i1,m1)=mr0;
L1_:
END_PROFILING:

end:        JUMP END;

.ENDMOD;