;  benchmark program  : n_complex_updates_arc.asm
; 
;  benchmark suite    : DSP-kernel
;
;  description        : benchmarking of a n complex updates operation
;
;  reference          : none
;
;  func. verification : with sim5x simulator 
;
;  organization       : Aachen University of Technology - IS2
;                     : DSP Tools Group
;                     : phone   : +49(241)807887
;                     : fax     : +49(241)8888195
;                     : e-mail  : zivojnov@ert.rwth-aachen.de
;
;  author             : Juan Martinez Velarde
;
;  history            : 26-05-94 - assembler reference code creation 
;                       26-05-94 - assembler reference code profiling

        .mmregs

        .file  "n_complex_updates_arc.asm"
        .title "n_complex_updates assembler reference code"
	.width 120

A		.set 	060h
B		.set	0300h
C        	.set	0320h
D		.set	0340h

	.sect "avalues"
	.word 	2,1,2,1,2,1,2,1,2,1,2,1,2,1,2,1
	.word 	2,1,2,1,2,1,2,1,2,1,2,1,2,1,2,1
;		^
;		0x60-0x7f

	.sect "bvalues"
	.word 	2,5,2,5,2,5,2,5,2,5,2,5,2,5,2,5
	.word 	2,5,2,5,2,5,2,5,2,5,2,5,2,5,2,5
;		^
;		0x300-0x31f

	.sect "cvalues"
	.word 	3,4,3,4,3,4,3,4,3,4,3,4,3,4,3,4
	.word 	3,4,3,4,3,4,3,4,3,4,3,4,3,4,3,4
;		^
;		0x320-0x33f

	.sect "dvalues"
	.word	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.word	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
;		^
;		0x340-0x35f

        .sect ".text"
INIT:
        LAR        AR1,#A         
	LAR	   AR2,#B
	LAR	   AR3,#C
	LAR	   AR4,#D
	ZPR		 ; zero product register 	
	LACC	   0	 ; clear accumulator
        MAR        *,AR3 ; point to #C

START_PROFILING:
	LACK	15	;n complex updates
	SAMM	BRCR	;load block repeat
			;counter register
	RPTB	L1-1	;

	LACC	*+,AR1	;accu = cir
	LT	*+,AR2	;treg = air,arp = ar2
	MPY	*+,AR1	;preg = air*bir,arp = ar1
	APAC		;accu = cir + air*bir
	LT	*-,AR2  ;treg = aii,arp = ar2
	MPY	*,AR4   ;preg = aii*bii,arp = ar4
	SPAC	        ;accu = cir + air*bir - aii*bii
	SACL	*+,AR3	;store dir
	
	LACC	*+,AR1  ;accu = cii
	LT	*+,AR2	;treg = air,arp = ar2
	MPY	*-,AR1  ;preg = air*bii,arp = ar1
	APAC		;accu = cii + air*bii
	LT	*+,AR2	;treg = aii,arp = ar2
	MPY	*+,AR4	;preg = aii*bir,arp = ar4
	APAC		;accu = cii + air*bii + aii*bir
	SACL	*+,AR2	;store dii
	MAR	*+,AR3  ;update pointer ar2,arp = ar3

L1:
END_PROFILING:

END:        B END

        .end