;  benchmark program  : n_real_updates_arc.asm
; 
;  benchmark suite    : DSP-kernel
;
;  description        : benchmarking of a n real updates operation
;
;  reference          : none
;
;  func. verification : with sim5x simulator 
;
;  organization       : Aachen University of Technology - IS2
;                     : DSP Tools Group
;                     : phone   : +49(241)807887
;                     : fax     : +49(241)8888195
;                     : e-mail  : zivojnov@ert.rwth-aachen.de
;
;  author             : Juan Martinez Velarde
;
;  history            : 26-05-94 - assembler reference code creation 
;                       26-05-94 - assembler reference code profiling

        .mmregs

        .file  "n_real_updates_arc.asm"
        .title "n_real_updates assembler reference code"
	.width 120

A		.set 	060h
B		.set	070h
C        	.set	0300h
D		.set	0310h

	.sect "avalues"
	.word 	10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10
;		^
;		0x60-0x6f

	.sect "bvalues"
	.word 	2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2
;		^
;		0x70-0x7f

	.sect "cvalues"
	.word 	10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10
;		^
;		0x300-0x30f

	.sect "dvalues"
	.word	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
;		^
;		0x310-0x31f

        .sect ".text"
INIT:
        LAR        AR1,#A         
	LAR	   AR2,#B
	LAR	   AR3,#C
	LAR	   AR4,#D
	ZPR		 ; zero product register 	
	LACC	   0	 ; clear accumulator
        MAR        *,AR3 ; point to #C

START_PROFILING:
	LACK	15	;n real updates
	SAMM	BRCR	;load block repeat
			;counter register
	RPTB	L1-1	;
	LACC	*+,AR1	;accu = ci
	LT	*+,AR2	;treg = ai,arp = ar2
	MPY	*+,AR4	;preg = ai*bi,arp = ar4
	APAC		;accu = ci + ai*bi
	SACL	*+,AR3	;store di
L1:
END_PROFILING:

END:        B END

        .end