;/*
; * benchmark program:   n_real_updates_arc2.asm
; * 
; * benchmark suite:     DSP-kernel
; * 
; * description:         n_real_updates - filter benchmarking
; * 
; * This program performs n real updates of the form 
; *           D(i) = C(i) + A(i)*B(i),
; * where A(i), B(i), C(i) and D(i) are real numbers,
; * and i = 1,...,N
; * 
; * reference code:      target assembly
; * 
; * f. verification:     simulator based
; * 
; *  organization:        Aachen University of Technology - IS2 
; *                       DSP Tools Group
; *                       phone:  +49(241)807887 
; *                       fax:    +49(241)8888195
; *                       e-mail: zivojnov@ert.rwth-aachen.de 
; *
; * author:              Juan Martinez Velarde
; * 
; * history:             24-5-94 creation (Martinez Velarde)
; * 
; */
	section n_real_updates_arc2
	opt	so,nomd,cc


N	equ	16	; number of updates

        org     x:
V__a:   
	dc      10
	dc	1
	dc      10
	dc	1
	dc      10
	dc	1
	dc      10
	dc	1
	dc      10
	dc	1
	dc      10
	dc	1
	dc      10
	dc	1
	dc      10
	dc	1
	dc      10
	dc	1
	dc      10
	dc	1
	dc      10
	dc	1
	dc      10
	dc	1
	dc      10
	dc	1
	dc      10
	dc	1
	dc      10
	dc	1
	dc      10
	dc	1

V__c:   
	dc      2	
	dc      0
   	dc      2	
	dc      0
   	dc      2	
	dc      0
   	dc      2	
	dc      0
   	dc      2	
	dc      0
   	dc      2	
	dc      0
   	dc      2	
	dc      0
   	dc      2	
	dc      0
   	dc      2	
	dc      0
   	dc      2	
	dc      0
   	dc      2	
	dc      0
	dc      2	
	dc      0
   	dc      2	
	dc      0
   	dc      2	
	dc      0	
	dc      2	
	dc      0
	dc      2	
	dc      0


LC0	dc	'd',$3D,$25,'i',$0A,$0A,$00

	org	p:
	global	Fmain
Fmain
	move	ssh,x:(r2)+

        move 	#V__a,r0
        move 	#V__c,r3
	clr	a
	nop

	START_PROFILING:
	
	do	#N,END_PROFILING

        move    x:(r0)+,x1	x:(r3)+,x0 ;x1=ai,x0=bi
	move	x:(r0)+,a0                 ;a=ci
        asl	a
	mac    	x0,x1,a            	   ;di=ci+ai*bi
	asr	a
	move            a0,x:(r3)+         ;store d

	END_PROFILING:

; **************************************************
	
        move 	#V__c+1,r3
	move	#LC0,r1
	move	#2,n3
	
	do	#N,ENDLOOP
	clr 	b
	move	x:(r3)+n3,b
	move	b,x:(r2)+
	move	r1,x:(r2)+
	jsr	Fprintf
	move 	(r2)-
	move	(r2)-

ENDLOOP:

; **************************************************

	move	x:-(r2),ssh
	rts
	endsec