;/*
; * benchmark program:   n_real_updates_arc.asm
; * 
; * benchmark suite:     DSP-kernel
; * 
; * description:         n_real_updates - filter benchmarking
; * 
; * This program performs n real updates of the form 
; *           D(i) = C(i) + A(i)*B(i),
; * where A(i), B(i), C(i) and D(i) are real numbers,
; * and i = 1,...,N
; * 
; * reference code:      target assembly
; * 
; * f. verification:     simulator based
; * 
; *  organization:        Aachen University of Technology - IS2 
; *                       DSP Tools Group
; *                       phone:  +49(241)807887 
; *                       fax:    +49(241)8888195
; *                       e-mail: zivojnov@ert.rwth-aachen.de 
; *
; * author:              Juan Martinez Velarde
; * 
; * history:             13-5-94 creation (Martinez Velarde)
; * 
; */
	section n_real_updates_arc
	opt	so,nomd,cc

N	equ	16	; number of update

        org     x:$0
V__A:   dc      4194303
	dc      4194303
	dc      4194303
	dc      4194303
	dc      4194303
	dc      4194303
	dc      4194303
	dc      4194303
	dc      4194303
	dc      4194303
	dc      4194303
	dc      4194303
	dc      4194303
	dc      4194303
	dc      4194303
	dc      4194303

V__C:   dc      1
	dc	1
	dc	1
	dc	1
	dc	1
	dc	1
	dc	1
	dc	1
	dc	1
	dc	1
	dc	1
	dc	1
	dc	1
	dc	1
	dc	1
	dc	1

        org     y:$0
V__B:   dc      2
	dc      2
	dc      2
	dc      2
	dc      2
	dc      2
	dc      2
	dc      2
	dc      2
	dc      2
	dc      2
	dc      2
	dc      2
	dc      2
	dc      2
	dc      2

V__D:   dc      0
	dc      0
	dc      0
	dc      0
	dc      0
	dc      0
	dc      0
	dc      0
	dc      0
	dc      0
	dc      0
	dc      0
	dc      0
	dc      0
	dc      0
	dc      0

LC0	dc	'd',$3D,$25,'i',$0A,$0A,$00

	org	p:
	global	Fmain
Fmain
	move	ssh,y:(r6)+

        move 	#V__A,r3
	move	#V__D,r2
        move 	#V__C,r1
	move	#V__B,r4
	clr	a
	nop

	START_PROFILING:

	do	#16,END_PROFILING

        move            x:(r1)+,a	           ;a=cr
	move	a,a0
	asl	a	x:(r3)+,x1  y:(r4)+,y1   ;x1=ar,y1=br
        mac    	y1,x1,a                            ;a-=ai*bi
	asr 	a
	move            a0,y:(r2)+                 ;store b
	
	END_PROFILING:

; **************************************************
	
	move	#V__D,r2

	do	#16,ENDLOOP
	clr 	a
	move	y:(r2)+,a0
	move	#LC0,r1
	move	a0,y:(r6)+
	move	r1,y:(r6)+
	jsr	Fprintf
	move 	(r6)-
	move	(r6)-
	ENDLOOP:

; **************************************************

	move	y:-(r6),ssh
	rts
	endsec