/*
 * benchmark program:   real_update_ext.c
 * 
 * benchmark suite:     DSP-kernel
 * 
 * description:         real_update - filter benchmarking
 * 
 * This program performs a real update of the form D = C + A*B,
 * where A, B, C and D are real numbers .
  * 
 * reference code:      target assembly
 * 
 * f. verification:     simulator based
 * 
 *  organization:        Aachen University of Technology - IS2 
 *                       DSP Tools Group
 *                       phone:  +49(241)807887 
 *                       fax:    +49(241)8888195
 *                       e-mail: zivojnov@ert.rwth-aachen.de 
 *
 * author:              Juan Martinez Velarde
 * 
 * history:             11-05-94 creation (Martinez Velarde)(real_update.c)
 *                      12-03-95 language extensions (Harald L. Schraut)
 *
 *                      $Author: schraut $
 *                      $Date: 1995/03/12 17:08:21 $
 *                      $Revision: 1.1 $
 */

#define STORAGE_CLASS register
#define TYPE  int

void
pin_down(TYPE *p)
{

  *p = 0 ; 

}


TYPE
main()
{
  static TYPE pm A = 10 ;
  static TYPE dm B = 2 ;
  static TYPE dm C = 1 ; 
  static TYPE dm D = 0 ; 
  
  STORAGE_CLASS TYPE pm *p_a = &A ;
  STORAGE_CLASS TYPE dm *p_b = &B ;
  STORAGE_CLASS TYPE dm *p_c = &C ;
  STORAGE_CLASS TYPE dm *p_d = &D ;
  
  pin_down(&D) ; 
  
  START_PROFILING; 
	  
  *p_d  = *p_c + *p_a * *p_b ;
   
  END_PROFILING; 
  
  pin_down(&D) ; 
  
  return(0)  ; 
}
