;  benchmark program  : real_update_arc.asm
; 
;  benchmark suite    : DSP-kernel
;
;  description        : benchmarking of a real_update operation
;
;  reference          : none
;
;  func. verification : with sim5x simulator 
;
;  organization       : Aachen University of Technology - IS2
;                     : DSP Tools Group
;                     : phone   : +49(241)807887
;                     : fax     : +49(241)8888195
;                     : e-mail  : zivojnov@ert.rwth-aachen.de
;
;  author             : Juan Martinez Velarde
;
;  history            : 25-05-94 - assembler reference code creation 
;                       25-05-94 - assembler reference code profiling

        .mmregs

        .file  "real_update_arc.asm"
        .title "real_update assembler reference code"
	.width 120

A		.set 	060h
B		.set	061h
C        	.set	062h
D		.set	063h

	.sect "avalue"
	.word 	10 		; a
;		^
;		0x60

	.sect "bvalue"
	.word 	2		; b
;		^
;		0x61

	.sect "cvalue"
	.word 	1		; c
;		^
;		0x62

	.sect "dvalue"
	.word	0		; d
;		^
;		0x63

        .sect ".text"
INIT:
        LAR        AR1,#A         
	LAR	   AR2,#B
	LAR	   AR3,#C
	LAR	   AR4,#D
	ZPR		 ; zero product register 	
	LACC	   0	 ; clear accumulator
        MAR        *,AR3 ; point to #C

START_PROFILING:

	LACC	*,AR1	;accu = c
	LT	*,AR2	;treg = a,arp = ar2
	MPY	*,AR4	;preg = a*b,arp = ar4
	APAC		;accu = c + a*b
	SACL	*,AR3	;store d

END_PROFILING:

END:        B END

        .end