;/*
; * benchmark program:   real_update_arc2.asm
; * 
; * benchmark suite:     DSP-kernel
; * 
; * description:         real_update - filter benchmarking
; * 
; * This program performs a real update of the form D = C + A*B,
; * where A, B, C and D are real numbers .
; * 
; * reference code:       Dr.Bub/56100/B.2.3 (modified)
; *
; * f. verification:     simulator based
; * 
; *  organization:        Aachen University of Technology - IS2 
; *                       DSP Tools Group
; *                       phone:  +49(241)807887 
; *                       fax:    +49(241)8888195
; *                       e-mail: zivojnov@ert.rwth-aachen.de 
; *
; * author:              Juan Martinez Velarde
; * 
; * history:             24-5-94 creation (Martinez Velarde)
; * 
; */
	section real_update_arc2
	opt	so,nomd,cc

        org     x:$0
;V__a:   dc      4194303

V__a:   dc      10
V__b:   dc      2
V__c:   dc      1
V__d:   dc      0

LC0	dc	'd',$3D,$25,'i',$0A,$0A,$00

	org	p:
	global	Fmain
Fmain
	move	ssh,x:(r2)+

        move 	#V__a,r0
        move 	#V__b,r3
	clr	a
	nop

	START_PROFILING:

        move    x:(r0)+,x1	x:(r3)+,x0 ;x1=a, x0=b
	move	x:(r3)+,a0                 ;a=c
        asl	a
	mac    	x0,x1,a            	   ;d = c + a*b
	asr	a
	move            a0,x:(r3)          ;store d

	END_PROFILING:

; **************************************************
	
	clr 	b
	move	x:(r3),b
	move	#LC0,r1
	move	b,x:(r2)+
	move	r1,x:(r2)+
	jsr	Fprintf
	move 	(r2)-
	move	(r2)-

; **************************************************

	move	x:-(r2),ssh
	rts
	endsec