-stack 0x0100                              /* 256 words STACK               */
-heap  0x0100                              /* 256 words HEAP                */

/* SPECIFY THE SYSTEM MEMORY MAP */

MEMORY
{
   ROM:    org = 0x000000  len = 0x1000     /* INTERNAL ROM (RESERVED)      */
                                            /* see User's Guide section 3.4 */
   RAM0:   org = 0x2FF800  len = 0x400      /* RAM BLOCK 0                  */
   RAM1:   org = 0x2FFC00  len = 0x400      /* RAM BLOCK 1                  */
   LOCAL:  org = 0x300000  len = 0x7D00000  /* LOCAL BUS                    */
   GLOBAL: org = 0x8000000 len = 0x8000000  /* GLOBAL BUS                   */
}

/* SPECIFY THE SECTIONS ALLOCATION INTO MEMORY */

SECTIONS
{
   .text:   > RAM0                   /* CODE                                */
   .cinit:  > ROM                    /* INITIALIZATION TABLES               */
   .const:  > RAM1                   /* CONSTANTS                           */
   .stack:  > RAM1                   /* SYSTEM STACK                        */
   .sysmem: > RAM1                   /* DYNAMIC MEMORY (HEAP)               */
   .bss:    > RAM1                   /* VARIABLES                           */
   .data:   > RAM1                   /* INITIALIZED DATA                    */
   .coeff:  > RAM0                   /* INITIALIZED DATA                    */
}
